/*
 * The contents of this file are subject to the JOnAS Public License Version 
 * 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License on the JOnAS web site.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.
 * See the License for the specific terms governing rights and limitations under 
 * the License.
 *
 * The Original Code is JOnAS application server code released July 1999.
 *
 * The Initial Developer of the Original Code is Bull S.A.
 * The Original Code and portions created by Bull S.A. are
 *    Copyright (C) 1999 Bull S.A. All Rights Reserved.
 *
 * Contributor(s): ______________________________________.
 *
 * --------------------------------------------------------------------------
 * $Id: UserTransactionFactory.java,v 1.6 2003/02/11 16:27:09 jmesnil Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jotm;

import java.util.Hashtable;
import javax.naming.Context;
import javax.naming.Name;
import javax.naming.Reference;
import javax.naming.spi.ObjectFactory;

public class UserTransactionFactory implements ObjectFactory {

    public Object getObjectInstance(Object objref, Name name, Context ctx, Hashtable env) throws Exception {

        Reference ref = (Reference) objref;
        Current ut = null;

        if (ref.getClassName().equals("javax.transaction.UserTransaction")
            || ref.getClassName().equals("org.objectweb.jotm.Current")) {

            // create the UserTransaction object
            // No need to init a TMFactory in the client!
            ut = new Current();

            // Get the timeout default value that was configured in the server
            String timeoutStr = (String) ref.get("jotm.timeout").getContent();
            Integer i = new Integer(timeoutStr);
            int timeout = i.intValue();
            ut.setDefaultTimeout(timeout);
        }
        return ut;
    }
}
